// Copyright (c) Microsoft Corporation.
// Licensed under the MIT License.

#include "pch.h"
#include <ChakraRuntimeArgs.h>
#include <ChakraRuntimeFactory.h>
#include <JsiReader.h>
#include <JsiWriter.h>
#include "CommonReaderTest.h"

namespace winrt::Microsoft::ReactNative {

TEST_CLASS (JsiReaderTest) {
  std::unique_ptr<::facebook::jsi::Runtime> m_runtime;

  JsiReaderTest() : m_runtime(::Microsoft::JSI::makeChakraRuntime(::Microsoft::JSI::ChakraRuntimeArgs{})) {}

  template <typename TCase>
  void RunReaderTest() {
    IJSValueWriter writer = winrt::make<JsiWriter>(*m_runtime);
    TCase::Write(writer);
    IJSValueReader reader = winrt::make<JsiReader>(*m_runtime, writer.as<JsiWriter>()->MoveResult());
    TCase::Read(reader);
  }

  IMPORT_READER_TEST_CASES
};

} // namespace winrt::Microsoft::ReactNative
